/*******************************************************************************
*                                 ZM4xx Demo
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-present Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
* e-mail:      ametal.support@zlg.cn
*******************************************************************************/

/**
 * \file
 * \brief ZM4xx Demo
 *
 * - 裺
 *   1.ʹUSBDEMOԣ򿪴֣Ϊ115200λ8bitֹͣλ1bitУλ
 *   2.ʹôն˷ݰ߰°S2ݰ
 *   3.ն˵ĴֿԲ鿴յݣ
 *   4.S3Ըı䷢书ʡ
 *
 * \internal
 * \par Modification history
 * - 1.00 17-11-22  sup, first implementation.
 * \endinternal
 */

#include "string.h"
#include "stddef.h"
#include "LPC11xx.h"                                                    /* LPC11xxĴ            */
#include "uart.h"
#include "stdint.h"
#include "radio.h"
#include "int.h"
#include "stdio.h"


#define FREQ          (433000000)
/* S2ݰ */
static char *__gp_test_str = "ZM4XX TEST !\r\n";

static uint8_t        __g_data_buf[256] = {0};
static uint8_t        __g_recv_pkt_cnt  = 0;                             
static uint16_t       __g_recv_byte     = 0;                                
static uint32_t       __g_send_byte     = 0;
static radio_handle_t __gp_handle;

extern void led_display (uint8_t val);


/**
 * \brief  S2ӦжϷһ
 */
static void __key2_int_handle (void)
{
    uint16_t  i = 0;
    for (i = 0; i < strlen(__gp_test_str); i++) {
        __g_data_buf[i] = __gp_test_str[i];
    }
    __g_send_byte  = strlen(__gp_test_str);
}

/**
 * \brief  S3жϷ,ı䷢书(5~20dBm)
 */
static void __key3_int_handle (void) 
{   
    static uint8_t pa_level = 0;
    static float   pa_val;
    
    /* ÿΰһС   */
    if (pa_level > 7) {
        pa_level = 0;
    }
    radio_pa_set(__gp_handle, pa_level, &pa_val);
    printf("tx power:%f\r\n", pa_val);
    pa_level++;
    led_display(pa_level);
}

/**
 * \brief  ģжϷ
 */
static void __radio_recv_int_handle (void)
{
    int      ret = 0;
    uint8_t  len;
    
    ret = radio_buf_recv(__gp_handle, __g_data_buf, &len);  /*    */
    if (ret == RADIO_RET_OK) {
        __g_recv_byte = len;
    }
}

void demo_zm4xx_entry (radio_handle_t handle)
{
    uint8_t  pkt_size = 0;
    uint16_t i = 0;
    
    __gp_handle = handle;

    /* Ƶ */
    radio_freq_set(handle, FREQ);
    
    /* Ϊ״̬  */
    radio_mode_set(handle, RX_MODE);

    /* ʼģж  */
    radio_int_init(handle,__radio_recv_int_handle);
    
    key2_int_init(__key2_int_handle);
    key3_int_init(__key3_int_handle);
    
    led_display(0x18);

    while (1) {

        /*    */
        if (__g_recv_byte > 0) {
            /*  ݴӴڷͳȥ  */
            for (i = 0; i < __g_recv_byte; i++) {
                uart_byte_send(__g_data_buf[i]);
            }

            /*  յLEDʾ1  */
            __g_recv_pkt_cnt++;
            led_display(__g_recv_pkt_cnt % 128);

            __g_recv_byte = 0;
            radio_mode_set(handle, RX_MODE); /* ½ģʽ */
        }

        /*    */
        if (__g_send_byte > 0) {            
            NVIC_DisableIRQ(UART_IRQn);       /* UARTж     */
            key_irq_disable();              /* رհж */
            
            led_display(0x80);

            radio_buf_send(handle, __g_data_buf, __g_send_byte);       /*    */
            
            radio_mode_set(handle, RX_MODE);
            
            led_display(__g_recv_pkt_cnt % 128);
            __g_send_byte = 0;
            NVIC_EnableIRQ(UART_IRQn);        /* ʹUARTж */
            key_irq_enable();               /* ж */
        }

        /* ӴڻȡҪ͵ݰ */
        if (uart_recv_pkt(__g_data_buf, &pkt_size) == 0) {
            __g_send_byte = pkt_size;
        }  
    }
}

