/*******************************************************************************
*                           ZM4xx Interface Demo
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-present Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
* e-mail:      support@zlg.cn
*******************************************************************************/

/**
 * \file
 * \brief ZM4xx Demo
 *
 * - 裺
 *   1.ʹUSBDEMOԣ򿪴֣Ϊ115200λ8bitֹͣλ1bitУλ
 *
 * - ʵ
     1. дӡ״̬
 * \internal
 * \par Modification history
 * - 1.00 17-11-22  sup, first implementation.
 * \endinternal
 */
 
#include "stddef.h"
#include "LPC11xx.h"                                                    /* LPC11xxĴ            */
#include "uart.h"
#include "stdint.h"
#include "radio.h"
#include "int.h"
#include "stdio.h"

#define FREQ          (433000000)

#define TEST_ZM4xxSX_L_MODULE
//#define TEST_ZM4xxSX_M_MODULE
//#define TEST_ZM4xxS_M_MODULE
//#define TEST_ZM7139_MODULE


#define TEST_FREQ_SET
#define TEST_MODE_SET
#define TEST_SYNC_ID
#define TEST_PREAMBLE
#define TEST_PREAMBLE

#ifdef TEST_SYNC_ID

#ifdef TEST_ZM4xxS_M_MODULE
#define TEST_ID_MAX_LEN       4
#define TEST_ID_ALOOW_LEN     2
#define TEST_PREAMBLE_LEN     10
#endif

#ifdef TEST_ZM4xxSX_L_MODULE
#define TEST_ID_MAX_LEN       4
#define TEST_ID_ALOOW_LEN     3
#define TEST_PREAMBLE_LEN     2
#endif

#endif


void demo_zm4xx_interface_test_entry (radio_handle_t handle)
{

    int      ret;
    uint8_t  temp;

    uint16_t i = 0;
    uint16_t prem_len;
    uint8_t  id[30], id_tmp[30];
    float    power;
    radio_state_t state;
     
    for (i = 0; i < sizeof(id); i++) {
        id[i] = i;
    }
    
    /* 1.Ƶ */
    printf("\r\n 1.freq set test:\r\n");
    ret = radio_freq_set(handle, FREQ);
    if (ret != RADIO_RET_OK) {
        printf("\t freq:%d set fail!\r\n", FREQ);
    } else {
        printf("\t freq:%d set ok!\r\n", FREQ);
    }
    
        
    /* 2. ݲ () 
     * ע⣺ շͷͷIDǰ һ
     */
    printf("\r\n 2.tx data test: \r\n");
    radio_buf_send(handle, "ZM4XX send data test!\r\n",  \
                               sizeof("ZM4XX send data test!\r\n"));  /*    */
    if (ret == RADIO_RET_OK) {
        printf("\t tx data ok of %d freq \r\n", FREQ );
    } else {
        printf("\t tx data fail!\r\n");
    }
        
    /* 3.ģʽ */
    printf("\r\n 3.mode set test:\r\n");
    ret = radio_mode_set(handle, RX_MODE);
    if (ret == RADIO_RET_OK) {
        printf("\t rx mode set ok!\r\n");
    } else {
        printf("\t rx mode set fail!\r\n");
    }
    
    /* 4.ͬID&ȡ */
    printf("\r\n 4.sync set&get test:\r\n");
    ret = radio_sync_id_set(handle, id, TEST_ID_ALOOW_LEN);
    if (ret == RADIO_RET_OK) {
        printf("\t sync id set ok!\r\n");
    } else {
        printf("\t sync id set fail!\r\n");
    }
    
    ret = radio_sync_id_get(handle, id_tmp, &temp);
    if (temp == TEST_ID_ALOOW_LEN) {
        for (i = 0; i < TEST_ID_ALOOW_LEN; i++) {
            if (id_tmp[i] != i) {
                break;
            } 
        }
        
        if (i >= TEST_ID_ALOOW_LEN) {
            printf("\t sync id get ok!\r\n");
        } else {
            printf("\t sync id val err!\r\n");
        }
    } else {
        printf("\t sync id len err!\r\n");
    }
    
    /* 5. ǰ*/
    printf("\r\n 5. preamble test:\r\n");
    ret = radio_preamble_length_set(handle, TEST_PREAMBLE_LEN);
    if (ret == RADIO_RET_OK) {
        printf("\t preamble set ok!\r\n");
    } else {
        printf("\t preamble set fail!\r\n");
    }
    
    ret = radio_preamble_length_get(handle, &prem_len);
    if (ret == RADIO_RET_OK) {
        if (prem_len == TEST_PREAMBLE_LEN) {
            printf("\t preamble get ok!\r\n");
        } else {
            printf("\t preamble len err!\r\n");
        }
    } else {
        printf("\t preamble set fail!\r\n");
    }
    
    /* 6. ʲ */
    printf("\r\n 6. power test:\r\n");
    for (i = 0; i < 8; i++) {
        ret = radio_pa_set(handle, i, &power);
        if (ret == RADIO_RET_OK) {
            printf("\t pa set ok! level:%d power:%f\r\n", i, power);
        } else {
            printf("\t pa set fail!\r\n");
        }
    }
    
    /* 7. ״̬ȡ*/
    printf("\r\n 7.state get test: \r\n");
    radio_state_get(handle, &state);
    if (ret == RADIO_RET_OK) {
        if (state == RX_RUNING_ST) {
            printf("\t state get ok!\r\n");
        } else {
            printf("\t state err!\r\n");
        }
    } else {
        printf("\t state get fail!\r\n");
    }
    while (1) {
    }
}

