/*******************************************************************************
*                                 ZM4xx Demo
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-present Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
* e-mail:      ametal.support@zlg.cn
*******************************************************************************/

/**
 * \file
 * \brief ZM4xx  RX Demo
 *
 * - 裺
 *   1.ʹUSBDEMOԣ򿪴֣Ϊ115200λ8bitֹͣλ1bitУλ
 
 * - ʵ
     2. ܵͨڴӡ
 
 * \internal
 * \par Modification history
 * - 1.00 17-11-22  sup, first implementation.
 * \endinternal
 */
 
#include "stddef.h"
#include "LPC11xx.h" 
#include "uart.h"
#include "stdint.h"
#include "radio.h"
#include "int.h"
#include "stdio.h"


#define FREQ          (433000000)

static uint8_t        __g_data_buf[256] = {0};                           
static uint16_t       __g_recv_byte     = 0;                                
static radio_handle_t __gp_handle;


/**
 * \brief  ģжϷ
 */
static void __radio_recv_int_handle (void)
{
    int      ret = 0;
    uint8_t  len;
    
    ret = radio_buf_recv(__gp_handle, __g_data_buf, &len);  /*    */
    if (ret == RADIO_RET_OK) {
        __g_recv_byte = len;
    }
}

void demo_zm4xx_rxdata_test (radio_handle_t handle)
{

    uint16_t i = 0;
    
    __gp_handle = handle;

      /* Ƶ */
    radio_freq_set(handle, FREQ);
    
    /* Ϊ״̬  */
    radio_mode_set(handle, RX_MODE);

    /* ʼģж  */
    radio_int_init(handle, __radio_recv_int_handle);

    while (1) {

        /*    */
        if (__g_recv_byte > 0) {
            /*  ݴӴڷͳȥ  */
            for (i = 0; i < __g_recv_byte; i++) {
                uart_byte_send(__g_data_buf[i]);
            }
            radio_mode_set(handle, RX_MODE);
            __g_recv_byte = 0;
        }
                
    }
}

