/*******************************************************************************
*                                 ZM4xx Demo
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-present Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
* e-mail:      ametal.support@zlg.cn
*******************************************************************************/

/**
 * \file
 * \brief ZM4xx Demo
 *
 * - 裺
 *   1.ʹUSBDEMOԣ򿪴֣Ϊ115200λ8bitֹͣλ1bitУλ
 *   2.ֽͨݷ͸demo
 *
 * \internal
 * \par Modification history
 * - 1.00 17-11-22  sup, first implementation.
 * \endinternal
 */
 
#include "stddef.h"
#include "LPC11xx.h"                                                    /* LPC11xxĴ            */
#include "uart.h"
#include "stdint.h"
#include "radio.h"
#include "int.h"
#include "stdio.h"

#define FREQ          (433000000)

static uint8_t        __g_data_buf[256] = {0};

void demo_zm4xx_txdata_test (radio_handle_t handle)
{
    uint8_t  pkt_size = 0;
    
    /* Ƶ */
    radio_freq_set(handle, FREQ);
    
    while (1) {

        /*    */
        if (pkt_size > 0) {            
            NVIC_DisableIRQ(UART_IRQn);       /* UARTж     */
                    
            radio_buf_send(handle, __g_data_buf, pkt_size);       /*    */
            
            NVIC_EnableIRQ(UART_IRQn);        /* ʹUARTж */
        }

        /* ӴڻȡҪ͵ݰ */
        if (uart_recv_pkt(__g_data_buf, &pkt_size) != 0) {
            pkt_size = 0; 
        }  
    }
}

