/*******************************************************************************
*                                 ZM4xx GPIO Driver 
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2017 Guangzhou ZHIYUAN Electronics Stock Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
* e-mail:      ametal.support@zlg.cn
*******************************************************************************/

/**
 * \file
 * \brief ZM4xx GPIO
 *
 * \internal
 * \par Modification history
 * - 1.00 17-11-22  sup, first implementation.
 * \endinternal
 */
 
#ifndef __ZM4XX_GPIO_H__
#define __ZM4XX_GPIO_H__
 
#include "stdint.h"
 
#define RST_PIN         (1ul << 3)                              /* P0_3 RST  */
#define SEL_PIN         (1ul << 2)                              /* P0_2 SEL  */
#define DIO0_PIN        (1ul << 4)                              /* P0_4 DIO0 */
#define DIO1_PIN        (1ul << 1)                              /* P2_1 DIO1 */
#define DIO2_PIN        (1ul << 2)                              /* P2_2 DIO2 */
#define DIO3_PIN        (1ul << 3)                              /* P2_3 DIO3 */
#define DIO5_PIN        (1ul << 5)                              /* P3_5 DIO5 */
    
#define IRQPIN_1()      ((LPC_GPIO2->DATA & IRQP_1) != 0)      

/* zm4xxųʼ  */
int zm4xx_pin_init (void);

/* zm4xxRESETŵƽ */
void zm4xx_rst_pin_set (uint8_t val);

/* zm4xxSELŵƽ */
void zm4xx_sel_pin_set (uint8_t val);

/* zm4xxDIO0ŵƽ */
uint8_t zm4xx_dio0_pin_read (void);

/* zm4xxDIO1ŵƽ */
uint8_t zm4xx_dio1_pin_read (void);

/* zm4xxDIO2ŵƽ */
uint8_t zm4xx_dio2_pin_read (void);

/* zm4xxDIO3ŵƽ */
uint8_t zm4xx_dio3_pin_read (void);

/* zm4xxDIO5ŵƽ */
uint8_t zm4xx_dio5_pin_read (void);
 
#endif
