/*******************************************************************************
*                             Interrupt process
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2017 Guangzhou ZHIYUAN Electronics Stock Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
* e-mail:      ametal.support@zlg.cn
*******************************************************************************/

/**
 * \file
 * \brief жϴ
 *
 * \internal
 * \par Modification history
 * - 1.00 17-11-22  sup, first implementation.
 * \endinternal
 */
 
 #include "LPC11xx.h"
 #include "int.h"
 #include "zm4xx_gpio.h"

 
/* жϴص */
static pfnvoid_t  __g_key2_int_handle;
static pfnvoid_t  __g_key3_int_handle;

/* ZM4XX ģж ص */
static pfnvoid_t  __g_radio_recv_int_handle;

static radio_handle_t __gp_handle;

static void __delay_ms (uint32_t ms)
{
    uint32_t i = 0;
    uint32_t j = 0;
    while (i < ms) {
        i++;
        for(j = 0; j < 4369; j++);
    }
}

/**
 * \brief  S2Ӧжϳʼ
 */
static void __key2_init (void)
{
    LPC_GPIO1->DIR &= ~ (1ul << 2);                                     /* P1.2Ϊ              */
    LPC_GPIO1->IS   = 0x00;                                             /* P1.2Ϊж              */
    LPC_GPIO1->IEV &= (1ul << 2);                                       /* ½ж                  */
    LPC_GPIO1->IE  |= (1ul << 2);                                       /* P1.2жϲ              */
    NVIC_EnableIRQ(EINT1_IRQn);                                         /* ȼ                   */
    NVIC_SetPriority(EINT1_IRQn, 2);
}

/**
 * \brief  S3жϳʼ
 */
static void __key3_init (void)
{
    LPC_GPIO0->DIR &= ~ (1ul << 7);                                     /*  P0.7Ϊ              */
    LPC_GPIO0->IS   = 0x00;                                             /*  P0.7Ϊж              */
    LPC_GPIO0->IEV &= ~(1ul << 7);                                      /*  ½ж                  */
    LPC_GPIO0->IE  |= (1ul << 7);                                       /*  P0.7жϲ              */
    NVIC_EnableIRQ(EINT0_IRQn);                                         /* жϲʹ               */
    NVIC_SetPriority(EINT0_IRQn, 2);
    LPC_GPIO0->IC |= (1ul << 7);                                        /*  жϱ־                */
}


/**
 * \brief  رհж
 */
void key_irq_disable (void)
{  
    LPC_GPIO1->IE &= ~(1ul << 2);  /* رS2ж */
    LPC_GPIO0->IE &= ~(1ul << 7);  /* رS3ж */
}

/**
 * \brief  ָж
 */
void key_irq_enable (void)
{
    LPC_GPIO0->IC |= (1ul << 7);
    LPC_GPIO1->IC |= (1ul << 2);
    LPC_GPIO0->IE |= (1ul << 7);
    LPC_GPIO1->IE |= (1ul << 2); 
}


/*******************************************************************************************/

/**
 * \brief  ʼģIRQ1ж
 * \return 
 */
static void __rf_irq1_init (void)
{
    /* DIO0ж */
    LPC_GPIO0->DIR &= ~DIO0_PIN;                 /*  P0.4Ϊ              */
    LPC_GPIO0->IS  &= ~DIO0_PIN;                 /*  P0.4Ϊж              */
    LPC_GPIO0->IEV |= DIO0_PIN;                  /*  ж                  */
    LPC_GPIO0->IE  |= DIO0_PIN;                  /*  P0.4жϲ              */        
    NVIC_EnableIRQ(EINT0_IRQn);                  /*  жϲʹ               */
    NVIC_SetPriority(EINT0_IRQn, 2);    
    LPC_GPIO0->IC |= DIO0_PIN;   
    
    /* DIO1DIO2DIO3ж */
    LPC_GPIO2->DIR &= ~(DIO1_PIN | DIO2_PIN | DIO3_PIN);               /*                */
    LPC_GPIO2->IS  &= ~(DIO1_PIN | DIO2_PIN | DIO3_PIN);               /*  ж          */
    LPC_GPIO2->IEV |= DIO1_PIN | DIO2_PIN | DIO3_PIN;                  /*  ж        */
    LPC_GPIO2->IE  |= DIO1_PIN | DIO2_PIN | DIO3_PIN;                  /*  жϲ        */        
    NVIC_EnableIRQ(EINT2_IRQn);                                        /*  жϲʹ    */
    NVIC_SetPriority(EINT2_IRQn, 2);    
    LPC_GPIO2->IC |= DIO1_PIN | DIO2_PIN | DIO3_PIN; 

//    /* DIO5ж */
//    LPC_GPIO3->DIR &= ~DIO5_PIN;                 /*  P2.1Ϊ              */
//    LPC_GPIO3->IS  |= DIO5_PIN;                  /*  P2.1Ϊƽж              */
//    LPC_GPIO3->IEV |= DIO5_PIN;                  /*  ߵƽж                  */
//    LPC_GPIO3->IE  |= DIO5_PIN;                  /*  P2.1жϲ              */        
//    NVIC_EnableIRQ(EINT3_IRQn);                                        /*  жϲʹ               */
//    NVIC_SetPriority(EINT3_IRQn, 2);    
//    LPC_GPIO3->IC |= DIO5_PIN;   
}

void radio_rcv_int_disable (void)
{
    NVIC_DisableIRQ(EINT2_IRQn);
}

void radio_rcv_int_enable (void)
{
    LPC_GPIO2->IC |= (1ul << 1);                                      /*  жϱ־                */  
    NVIC_ClearPendingIRQ(EINT2_IRQn);
    NVIC_EnableIRQ(EINT2_IRQn);
}   

/*******************************************************************************************/
 
 void PIOINT0_IRQHandler (void)
{  
    if (LPC_GPIO0->MIS & (1ul << 7)) {
        __delay_ms(5);
        while (!(LPC_GPIO0->DATA & (1ul << 7)));     /*  ȴɿ */        
        if(__g_key3_int_handle) {
                __g_key3_int_handle();
        }
        
    } else if (LPC_GPIO0->MIS & DIO0_PIN) {
        radio_dio0_irq_func(__gp_handle);
        if( __g_radio_recv_int_handle ) {
            __g_radio_recv_int_handle();
        }
    }
    
    LPC_GPIO0->IC |= (1ul << 7) | DIO0_PIN;    
}

void PIOINT1_IRQHandler  (void)
{
    __delay_ms(5);
    while(!(LPC_GPIO1->DATA & (1ul << 2)));   /* ȴɿ  */
    if( __g_key2_int_handle) {
        __g_key2_int_handle();
    }
    LPC_GPIO1->IC |= (1ul << 2);             /*  жϱ־  */
}
void PIOINT2_IRQHandler(void)
{
    if( __g_radio_recv_int_handle ) {
        __g_radio_recv_int_handle();
    }
    LPC_GPIO2->IC |= (1ul << 1);    /*  жϱ־  */
    
    if (LPC_GPIO2->MIS & DIO1_PIN) {
        radio_dio1_irq_func(__gp_handle);
    } else if (LPC_GPIO2->MIS & DIO2_PIN) {
        radio_dio2_irq_func(__gp_handle);
    } else if (LPC_GPIO3->MIS & DIO3_PIN) {
        radio_dio3_irq_func(__gp_handle);
    }
    
    LPC_GPIO2->IC |= DIO1_PIN | DIO2_PIN | DIO3_PIN;

}

void PIOINT3_IRQHandler(void) 
{
    if (LPC_GPIO3->MIS & DIO5_PIN) {
        radio_dio5_irq_func(__gp_handle);
    }
    
    LPC_GPIO3->IC |= DIO5_PIN;
}


/*
 * \brief ʼ 
 */
void key2_int_init(pfnvoid_t key2_int_cb)
{
     __key2_init();
     __g_key2_int_handle = key2_int_cb;
}

void key3_int_init(pfnvoid_t key3_int_cb)
{
     __key3_init();
     __g_key3_int_handle = key3_int_cb;
}

void radio_int_init (radio_handle_t handle,pfnvoid_t radio_int_cb)
{
    __gp_handle = handle;
    __rf_irq1_init();
    __g_radio_recv_int_handle = radio_int_cb;
}
