/*******************************************************************************
*                                 ZM4xx gpio Driver 
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2017 Guangzhou ZHIYUAN Electronics Stock Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
* e-mail:      ametal.support@zlg.cn
*******************************************************************************/

/**
 * \file
 * \brief ZM4xx GPIO
 *
 * \internal
 * \par Modification history
 * - 1.00 17-11-22  sup, first implementation.
 * \endinternal
 */
 
#include "zm4xx_gpio.h"
#include "LPC11xx.h"                                                    /* LPC11xxĴ            */
#include "LPC11xx_pinsel.h"
#include "LPC11xx_ssp.h"

int zm4xx_pin_init (void)
{
    LPC_GPIO0->DIR |= RST_PIN | SEL_PIN;                 /*  */
    LPC_GPIO0->DIR &= ~DIO0_PIN;                         /*  */
    LPC_GPIO2->DIR &= ~(DIO1_PIN | DIO2_PIN | DIO3_PIN); /*  */
    LPC_GPIO3->DIR &= ~DIO5_PIN;                         /*  */
     
    LPC_GPIO0->DATA |=  RST_PIN | SEL_PIN; /* ʼΪߵƽ */
    
    return 0;
}
 
 
 
 
void zm4xx_rst_pin_set (uint8_t val)
{
    if (val == 1) {
        LPC_GPIO0->DATA |= RST_PIN;
    } else if (val == 0) {
        LPC_GPIO0->DATA &= ~RST_PIN;
    }
}
 
 
 
 
void zm4xx_sel_pin_set (uint8_t val)
{
    if (val == 1) {
        LPC_GPIO0->DATA |= SEL_PIN;
    } else if (val == 0) {
        LPC_GPIO0->DATA &= ~SEL_PIN;
    }
}




uint8_t zm4xx_dio0_pin_read (void)
{
    return ((LPC_GPIO0->DATA & DIO0_PIN) != 0);
}




uint8_t zm4xx_dio1_pin_read (void)
{
    return ((LPC_GPIO2->DATA & DIO1_PIN) != 0);
}




uint8_t zm4xx_dio2_pin_read (void)
{
    return ((LPC_GPIO2->DATA & DIO2_PIN) != 0);
}




uint8_t zm4xx_dio3_pin_read (void)
{
    return ((LPC_GPIO2->DATA & DIO3_PIN) != 0);
}



uint8_t zm4xx_dio5_pin_read (void)
{
    return ((LPC_GPIO3->DATA & DIO5_PIN) != 0);
}