/*******************************************************************************
*                                 Main
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2017 Guangzhou ZHIYUAN Electronics Stock Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
* e-mail:      ametal.support@zlg.cn
*******************************************************************************/

/**
 * \file
 * \brief   ʼذ弶Դ 
 *
 * \internal
 * \par Modification history
 * - 1.00 18-06-29  vir, first implementation.
 * \endinternal
 */

#include "stddef.h"
#include "LPC11xx.h"
#include "spi.h"
#include "uart.h"
#include "timer.h"
#include "zm4xx_gpio.h"

#define LED_INIT()    LPC_GPIO2->DIR  |=  0XFF0                         /* LEDʼ                    */

/* LED ʾ */
void led_display (uint8_t val)
{
    uint8_t temp = 0;

    temp |= (val & (1ul << 7)) >> 5;   /* LED7,DIO6 */
    temp |= (val & (1ul << 6)) >> 3;   /* LED6,DIO7 */
    temp |= (val & (1ul << 5)) >> 1;   /* LED5,DIO8 */
    temp |= (val & (1ul << 4)) >> 4;   /* LED4,DIO4 */
    temp |= (val & (1ul << 3)) >> 2;   /* LED3,DIO5 */
    temp |= (val & (1ul << 2)) << 3;   /* LED2,DIO9 */
    temp |= (val & (1ul << 1)) << 5;   /* LED1,DIO10*/
    temp |= (val & (1ul << 0)) << 7;   /* LED0,DIO11*/

    LPC_GPIO2->DATA &= 0x00f;
    LPC_GPIO2->DATA |= ~(temp << 4);
}

/* 弶ʼ */
void board_init(void)
{
	  /* ϵͳʼ11.0592MHz   */
    SystemInit();
    LPC_SYSCON->SYSAHBCLKCTRL |= (1 << 6);
    
	  /* MUC ʼ */
    zm4xx_pin_init(); /* ģųʼSPIų⣩ */
    spi_init();       /* ģSPIʼ */
    uart_init(115200, 256, NULL);
    timer0_16_init();
	  timer0_32_init();
	
		/* ذ弶Դʼ */
    LED_INIT();
}
